// Plugin Tool Javascript and jQuery include file
// Copyright 2016-03-25 Troy Lea aka Box293


function plugintool_ToggleMenu(a) {
	// hide all menu elements 
   	$('.plugintool_togglediv').hide(); 
	// reset the last item that was selected
	$('.plugintool_menuheading2').addClass("plugintool_menuheading1").removeClass("plugintool_menuheading2");
	// show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id_' + a).addClass("plugintool_menuheading2").removeClass("plugintool_menuheading1");
	} // End function plugintool_ToggleMenu(a) {

	
function plugintool_toggleMe(a) {
	$('#'+ a).slideToggle();
	} // End function plugintool_toggleMe(a) {


function plugintool_toggleAll(a) {
	var topics = a.split(':');
	var toggleAllText = $('#expand_collapse').text();
	for (var i=0;i<topics.length;i++) {
		if (toggleAllText == 'Expand All') {
			$('#' + topics[i]).show();
			} // End if (toggleAllText == 'Expand All') {
		else if (toggleAllText == 'Collapse All') {
			$('#' + topics[i]).hide();
			} // End else if (toggleAllText == 'Collapse All') {
		} // End for (var i=0;i<topics.length;i++) {
	if (toggleAllText == 'Expand All') {
		$('#expand_collapse').text('Collapse All');
		} // End if (toggleAllText == 'Expand All') {
	else if (toggleAllText == 'Collapse All') {
		$('#expand_collapse').text('Expand All');
		} // End else if (toggleAllText == 'Collapse All') {
	} // End function plugintool_toggleAll(a) {


function plugintoolToggleCheckbox(a) {
	//window.alert("value is: " + a);
	if ($('#'+ a).is(':checked')) {
		$(".plugintool_checkbox").attr('checked', true);
		} // End if ($('#'+ a).is(':checked')) {
	else {
		$(".plugintool_checkbox").attr('checked', false);
		} // End else {
	} // End function plugintoolToggleCheckbox(a) {


function plugintool_perform_action(action) {
	//alert('Action = ' + action);
	
	// Define the test variables
	var all_ok = 0;
	
	// Perform the action and perform some validation testing
	switch (action) {
		case 'plugin_test_plugin_select':
			// Get the plugin selected
			var plugin_selected = $('#id_plugintool_plugin_test_plugin_select option:selected').val();
			//alert('plugin_selected = ' + plugin_selected);
			
			// Need to check if nothing was selected
			if (plugin_selected == '') {
				alert('You need to select a Plugin to test!');
				// Hide the selected_args DIV
				$('#id_plugintool_plugin_test_plugin_selected_args').hide();
				// Hide the arguments DIV
				$('#id_plugintool_plugin_test_plugin_arguments').hide();
				// Hide the submit button DIV
				$('#id_plugintool_plugin_test_submit_button').hide();
				all_ok = 1;
				} // End if (plugin_selected == '') {
			else {
				// Show the arg options
				plugintool_perform_action('plugin_test_plugin_selected_args');
				} // End else {
			break; // End case 'plugin_test_plugin_select':
		
		
		case 'plugin_test_plugin_selected_args':
			// Check to make sure an argument option was selected
			if ($('input[name=plugintool_plugin_test_plugin_selected_args]:checked').val()) {
				// Get the argument option
				var plugin_argument_option = $('input[name=plugintool_plugin_test_plugin_selected_args]:checked').val();
				//alert('plugin_argument_option = ' + plugin_argument_option);
				if (plugin_argument_option == 'with_args') {
					// Show the arguments DIV
					$('#id_plugintool_plugin_test_plugin_arguments').show();
					} // End if (plugin_argument_option == 'with_args') {
				else {
					// Hide the arguments DIV
					$('#id_plugintool_plugin_test_plugin_arguments').hide();
					} // End else {
				// Show the submit button DIV
				$('#id_plugintool_plugin_test_submit_button').show();
				} // End if ($('input[name=plugintool_plugin_test_plugin_selected_args]:checked').val()) {
			else {
				// Show the selected_args DIV
				$('#id_plugintool_plugin_test_plugin_selected_args').show();
				} // End else {
			break; // End case 'plugin_test_plugin_select':
		
		
		case 'plugin_test_submit':
			// Get the plugin selected
			var plugin_selected = $('#id_plugintool_plugin_test_plugin_select option:selected').val();
			//alert('plugin_selected = ' + plugin_selected);
			// Get the argument option
			var plugin_argument_option = $('input[name=plugintool_plugin_test_plugin_selected_args]:checked').val();
			//alert('plugin_argument_option = ' + plugin_argument_option);
			if (plugin_argument_option == 'with_args') {
				// Get the supplied argments
				var plugin_arguments = $('#id_plugintool_plugin_test_plugin_selected_args_arguments').val();
				if (plugin_arguments == '') {
					alert('You must provide some arguments to use with the Plugin!');
					all_ok = 1;
					} // End if (plugin_arguments == '') {
				else {
					// Perform a regexp on the arguments to test for allowed characters
					var plugin_arguments_regexp = /[^0-9a-zA-Z@%?,=+\"\'\ \.\:\_\-\[\]\/\\\\]/;
					var plugin_arguments_regexp_match = plugin_arguments_regexp.test(plugin_arguments);
					//alert('plugin_arguments_regexp_match ' + plugin_arguments_regexp_match);
					if (plugin_arguments_regexp_match == true) {
						// Characters not allowed were found
						alert('The Plugin arguments you provided contains invalid characters!');
						all_ok = 1;
						} // End if (plugin_arguments_regexp_match == true) {
					} // End else {
				} // End if (plugin_argument_option == 'with_args') {
			break; // End case 'plugin_test_submit':
		
		
		case 'command_test_command_select':
			//alert('Action = ' + action);
			// Get the command selected
			var command_selected = $('#id_plugintool_command_test_command_select option:selected').val();
			//alert('command_selected = ' + command_selected);
			// Need to check if nothing was selected
			if (command_selected == '') {
				//alert('You need to select a Command to test!');
				// Hide the command_test_table DIV
				$('#id_plugintool_command_test_table').hide();
				// Hide the submit button DIV
				$('#id_plugintool_command_test_submit_button').hide();
				all_ok = 1;
				} // End if (command_selected == '') {
			else {
				//alert('command_selected = ' + command_selected);
				$('#id_plugintool_command_test_table').load(
					'/nagiosxi/includes/components/plugintool/plugin_tool_do_stuff.php',
					{
						'request'			: 'command_test_draw_table',
						'command_selected'	: command_selected
						}); // End $('#id_plugintool_command_test_table').load(

				// Show the command_test_table DIV
				$('#id_plugintool_command_test_table').show();
				// Show the submit button DIV
				$('#id_plugintool_command_test_submit_button').show();
				} // End else {
			break; // End case 'command_test_command_select':
		
		
		case 'command_test_submit':
			// Get the command selected
			var command_selected = $('#id_plugintool_command_test_command_select option:selected').val();
			//alert('command_selected = ' + command_selected);
			// Get the command_line_macros_array
			var command_line_macros_array = jQuery.parseJSON(decodeURIComponent($('#id_command_line_macros_array').val()));
			// Define the array we will store the values in
			var command_line_macros_values_array = new Array();
			// Determine if there is a command_line_macros_array
			if (command_line_macros_array != 'none') {
				// Get the command_args_count
				var command_args_count = command_line_macros_array.length;
				// Now check each arg for characters not allowed
				for (var i = 0; i < command_args_count; i++) {
					// Get the current argument
					var current_argument = $('#id_command_test_command_arg_' + i).val();
					// Perform a regexp on the argument to test for allowed characters
					var current_argument_regexp = /[^0-9a-zA-Z@%?,=+\"\'\ \.\:\_\-\[\]\/\\\\]/;
					var current_argument_regexp_match = current_argument_regexp.test(current_argument);
					//alert('current_argument_regexp_match ' + current_argument_regexp_match);
					if (current_argument_regexp_match == true) {
						// Characters not allowed were found
						alert('The Command argument you provided for ' + command_line_macros_array[i] +' contains invalid characters!');
						all_ok = 1;
						} // End if (current_argument_regexp_match == true) {
					// Add the current_argument to command_line_macros_values_array
					command_line_macros_values_array[i] = current_argument;
					} // End for (var i = 0; i < command_args_count; i++) {
				} // End if (command_line_macros_array != 'none') {
			break; // End case 'command_test_submit':
		
		
		default:
		
			break; // End default:	
		} // End switch (action) {
	
	// Now perform more actions if the validation testing passed
	if (all_ok == 0) {
		switch (action) {
			case 'plugin_test_submit':
				// Define the Content DIV
				var plugintool_content_div_id = 'plugintool_content_' + action;
				
				// Open the window to display the throbber image
				var plugintool_plugin_test_window = window.open('/nagiosxi/includes/components/plugintool/plugin_tool_do_stuff.php?request=throbber&id=' + action,'_blank','width=1000,height=600,scrollbars=yes,resizable=yes');
				
				// Wait till the page has loaded
				plugintool_plugin_test_window.onload = new function() {
					// I needed to set a timeout as the opened window was not always being updated!
					setTimeout(function() {
						// Perform the plugin test via an ajax request
						$.ajax({
							type: 'GET',
							url: '/nagiosxi/includes/components/plugintool/plugin_tool_do_stuff.php',
							data: {
								'request'					: 'plugin_test',
								'plugin_selected'			: plugin_selected,
								'plugin_argument_option'	: plugin_argument_option,
								'plugin_arguments'			: encodeURIComponent(plugin_arguments),
								}, // End data: {
							async: false,
							}) // #End $.ajax({ 
							.done(function (response) {
								// Add the response to a child DIV
								plugintool_plugin_test_window.document.getElementById(plugintool_content_div_id).innerHTML += response;
								}); // End .done(function (response) {
						// Hide the throbber DIV
						plugintool_plugin_test_window.document.getElementById('plugintool_throbber_' + action).style.display = 'none';
						// Show the finished DIV
						plugintool_plugin_test_window.document.getElementById('plugintool_finished_' + action).style.display = 'block';
						},3000); // End setTimeout(function() {
					} // End plugintool_plugin_test_window.onload = new function() {
				break; // End case 'plugin_test_submit':
			
			
			case 'command_test_submit':
				// Define the Content DIV
				var plugintool_content_div_id = 'plugintool_content_' + action;
				
				// Open the window to display the throbber image
				var plugintool_command_test_window = window.open('/nagiosxi/includes/components/plugintool/plugin_tool_do_stuff.php?request=throbber&id=' + action,'_blank','width=1000,height=600,scrollbars=yes,resizable=yes');
				
				// Turning the command_line_macros_values_array into a JSON
				command_line_macros_values_array = JSON.stringify(command_line_macros_values_array);
				
				// Wait till the page has loaded
				plugintool_command_test_window.onload = new function() {
					// I needed to set a timeout as the opened window was not always being updated!
					setTimeout(function() {
						// Perform the plugin test via an ajax request
						$.ajax({
							type: 'GET',
							url: '/nagiosxi/includes/components/plugintool/plugin_tool_do_stuff.php',
							data: {
								'request'							: 'command_test',
								'command_selected'					: command_selected,
								'command_line_macros_array'			: $('#id_command_line_macros_array').val(),
								'command_line_macros_values_array' 	: encodeURIComponent(command_line_macros_values_array),
								}, // End data: {
							async: false,
							}) // #End $.ajax({ 
							.done(function (response) {
								// Add the response to a child DIV
								plugintool_command_test_window.document.getElementById(plugintool_content_div_id).innerHTML += response;
								}); // End .done(function (response) {
						// Hide the throbber DIV
						plugintool_command_test_window.document.getElementById('plugintool_throbber_' + action).style.display = 'none';
						// Show the finished DIV
						plugintool_command_test_window.document.getElementById('plugintool_finished_' + action).style.display = 'block';
						},3000); // End setTimeout(function() {
					} // End plugintool_command_test_window.onload = new function() {
				break; // End case 'command_test_submit':
			} // End switch (action) {
		} // End if (all_ok == 0) {
	} // End function plugintool_perform_action(action) {

	
