<?php  
// plugin_tool_do_stuff COMPONENT
//
// Copyright 2016-03-25 Troy Lea aka Box293
//

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);

/* Create the HTML Header */
?>
<!DOCTYPE html>
	<html>
	<head>
	<title>Nagios XI - Plugin Tool</title>
	<meta http-equiv='Content-Type' content='text/html; charset=UTF-8' />
	<?php
	do_page_head_links();
	?>
	<link href="../plugintool/plugin_tool.css" rel="stylesheet" type="text/css" />
	<script type="text/javascript" src="../plugintool/plugin_tool.js"></script>
	<script type="text/javascript" src="../../js/jquery/jquery.tablesorter.js"></script>
	</head>
<?php

/* This adds padding for XI 5.x onwards */
if (get_product_release() > 416) {
	?>
		<body style="padding: 0px 5px 5px 5px;">
	<?php
	} /* End if (get_product_release() > 416) { */
else {
	?>
		<body>
	<?php
	} /* End else { */

/* Get the request passed to us */
$plugintool_request = grab_request_var('request',false);

/* Process the request */
switch ($plugintool_request) {
	case 'plugin_test':
		/* Get the plugin_selected passed to us */
		$plugintool_plugin_selected = grab_request_var('plugin_selected',false);
		/* Get the plugin_argument_option passed to us */
		$plugintool_plugin_argument_option = grab_request_var('plugin_argument_option',false);
		/* Get the plugin_arguments passed to us */
		$plugintool_plugin_arguments = urldecode(grab_request_var('plugin_arguments',false));
		
		/* Define the array that the plugin test results will be stored in */
		$plugintool_plugin_test_results = array();
		/* Define the variable that the plugin test exit code will be stored in */
		$plugintool_plugin_test_exit_code = ''; 
		
		/* Build the command we will execute */
		$plugintool_plugin_test_command = '/usr/local/nagios/libexec/';
		$plugintool_plugin_test_command .= $plugintool_plugin_selected;
		if ($plugintool_plugin_argument_option == 'with_args') {
			$plugintool_plugin_test_command .= ' ';
			$plugintool_plugin_test_command .= $plugintool_plugin_arguments;
			} /* End if ($plugintool_plugin_argument_option == 'with_args') { */
		$plugintool_plugin_test_command_display = $plugintool_plugin_test_command;
		$plugintool_plugin_test_command .= ' ';
		$plugintool_plugin_test_command .= '2>&1';
				
		/* Perform the plugin test */		
		exec($plugintool_plugin_test_command, $plugintool_plugin_test_results, $plugintool_plugin_test_exit_code);
		
		/* Output the results */
		$html = '
			<h3>Command Executed:</h3>
			<div class="plugintool_font_terminal">'.$plugintool_plugin_test_command_display.'</div>
			
			<div class="plugintool_spacer10"> </div>
			
			<h3>Output:</h3>
			<table>
			';
		foreach($plugintool_plugin_test_results as $td){
			$convert = htmlentities($td);
			$html .= '<tr><td class="plugintool_font_terminal">'.$convert.'</td></tr>';
			}
		$html .= '
			</table>	
			
			<div class="plugintool_spacer10"> </div>
			
			<h3>Exit Code:</h3>
			<div class="plugintool_font_terminal">'.$plugintool_plugin_test_exit_code.' = '.plugintool_state($plugintool_plugin_test_exit_code).'<div>

			<div class="plugintool_spacer20"> </div>
			';
		print $html;
		break; /* End case 'plugin_test': */
	
	
	case 'command_test_draw_table':
		/* Get the command_selected array passed to us */
		$command_selected_array = json_decode(urldecode(grab_request_var('command_selected',false)), true);
		
		/* Get the known_macros_array */
		$known_macros_array = known_macros();
		
		/* Draw the command table */
		$html = '
			<table>
				<tr>
					<td><label>Enabled</label></td>
					<td>=</td>
					<td>		
			';
		/* Show if the command is active */
		switch ($command_selected_array['active']) {
			case 0:
				$html .= 'No';
				break; /* End case 0: */
			
			case 1:
				$html .= 'Yes';
				break; /* End case 0: */
			} /* End switch ($command_selected_array['active']) { */
		$html .= '
					</td>
				</tr>
				<tr>
					<td><label>Command Line</label></td><td>=</td><td>'.$command_selected_array['command_line'].'</td>
				</tr>
			';
		/* Find all the macros in the command line */
		preg_match_all('/\$(.*?)\$/', $command_selected_array['command_line'], $command_line_macros_array);
		/* Now create the remaining table */
		if (!empty($command_line_macros_array)) {
			
			for ($i = 0; $i < sizeof($command_line_macros_array[0]); $i++) {
				//$html .= $command_line_macros_array[0][$i] .'<br>';
				$field_value = '';
				/* Loop through the known macros to get their values */
				if (!empty($known_macros_array)) {
					for ($km = 0; $km < sizeof($known_macros_array); $km++) {
						/* Do the macros match? */
						if ($command_line_macros_array[0][$i] == $known_macros_array[$km]['macro_name']) {
							/* Set the value for the field */
							$field_value = $known_macros_array[$km]['macro_value'];
							} /* End if ($command_line_macros_array[0][$i] == $known_macros_array[$km]['macro_name']) { */
						} /* End for ($km = 0; $km < sizeof($known_macros_array); $km++) { */
					} /* End if (!empty($known_macros_array)) { */
				
				/* Now create the row in the table */
				$html .= '
				<tr>
					';
				if ($command_line_macros_array[0][$i] == '$USER1$') {
					$html .= '<td><label>$USER1$</label></td><td>=</td><td><input type="text" size="50" id="id_command_test_command_arg_'.$i.'" value="'.$field_value.'" readonly></td>';
					} /* End if ($command_line_macros_array[0][$i] == '$USER1$') { */
				else {
					$html .= '<td><label>'.$command_line_macros_array[0][$i].'</label></td><td>=</td><td><input type="text" size="50" id="id_command_test_command_arg_'.$i.'" value="'.$field_value.'"></td>';
					} /* End else { */
				$html .= '
				</tr>
					';
				} /* End for ($i = 0; $i < sizeof($command_line_macros_array[0]); $i++) { */
			} /* End if (!empty($command_line_macros_array)) { */
		$html .= '</table>';
		// Now put the hidden input
		if (!empty($command_line_macros_array)) {
			$html .= '<input type="hidden" id="id_command_line_macros_array" value="'.urlencode(json_encode($command_line_macros_array[0])).'">';
			} /* End if (!empty($command_line_macros_array)) { */
		else {
			$html .= '<input type="hidden" id="id_command_line_macros_array" value="none">';
			} /* End else { */
		print $html;
		break; /* End case 'command_test_draw_table': */
	
	
	case 'command_test':
		/* Get the command_selected_array passed to us */
		$command_selected_array = json_decode(urldecode(grab_request_var('command_selected',false)), true);
		
		/* Get the command_line_macros_array passed to us */
		$command_line_macros_array = json_decode(urldecode(grab_request_var('command_line_macros_array',false)), true);
		
		/* Get the command_line_macros_values_array passed to us */
		$command_line_macros_values_array = json_decode(urldecode(grab_request_var('command_line_macros_values_array',false)), true);
		
		/* Split the command_line so we can dynamically build the command line */
		$command_line_split = preg_split('/(\$.*?\$)/', $command_selected_array['command_line'], -1, PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE);
		
		/* Now build the command to execute */
		$plugintool_command_test_command = '';
		/* Loop through the command_line_split */
		for ($i = 0; $i < sizeof($command_line_split); $i++) {
			//print_r('split name ---'.$command_line_split[$i].'---<br/>');
			$command_line_split_value = $command_line_split[$i];
			/* Loop through the command_line_macros_array */
			for ($ma = 0; $ma < sizeof($command_line_macros_array); $ma++) {
				/* Does the current split object name match the macro name? */
				//print_r('macro name ---'.$command_line_macros_array[$ma].'---<br/>');
				if ($command_line_split[$i] == $command_line_macros_array[$ma]) {
					//print_r('split name matches macro name so the value is---'.$command_line_macros_values_array[$ma].'---<br/>');
					/* If it does, get the value from the command_line_macros_values_array */
					$command_line_split_value = $command_line_macros_values_array[$ma];
					} /* End if ($command_line_split[$i] == $command_line_macros_array[$ma]) { */
				} /* End for ($ma = 0; $ma < sizeof($command_line_macros_array); $ma++) { */
			/* Now add this part of the command to the existing command */
			$plugintool_command_test_command = $plugintool_command_test_command . $command_line_split_value;
			} /* End for ($i = 0; $i < sizeof($command_line_split); $i++) { */
		
		$plugintool_command_test_command_display = $plugintool_command_test_command;
		$plugintool_command_test_command .= ' ';
		$plugintool_command_test_command .= '2>&1';
				
		/* Perform the command test */		
		exec($plugintool_command_test_command, $plugintool_command_test_results, $plugintool_command_test_exit_code);
		
		/* Output the results */
		$html = '
			<h3>Command Executed:</h3>
			<div class="plugintool_font_terminal">'.$plugintool_command_test_command_display.'</div>
			
			<div class="plugintool_spacer10"> </div>
			
			<h3>Output:</h3>
			<table>
			';
		foreach($plugintool_command_test_results as $td){
			$convert = htmlentities($td);
			$html .= '<tr><td class="plugintool_font_terminal">'.$convert.'</td></tr>';
			}
		$html .= '
			</table>	
			
			<div class="plugintool_spacer10"> </div>
			
			<h3>Exit Code:</h3>
			<div class="plugintool_font_terminal">'.$plugintool_command_test_exit_code.' = '.plugintool_state($plugintool_command_test_exit_code).'<div>
			
			<div class="plugintool_spacer20"> </div>
			';
		print $html;
		break; /* End case 'comand_test': */
	
	
	case 'throbber':
		/* Get the id passed to us */
		$plugintool_throbber_id = grab_request_var('id',false);
		$plugintool_throbber_div_id = 'plugintool_'.$plugintool_request.'_'.$plugintool_throbber_id;
		$plugintool_finished_div_id = 'plugintool_finished_'.$plugintool_throbber_id;
		$plugintool_content_div_id = 'plugintool_content_'.$plugintool_throbber_id;
		$html = '
			<div id="'.$plugintool_throbber_div_id.'">
				<h3>Please wait while your request is processed</h3>
				'.get_throbber_html().'
				<br /><br />
			</div>
			<div id="'.$plugintool_finished_div_id.'" style="display:none">
				<h3>Finished request, check results below</h3>
			</div>
			<div id="'.$plugintool_content_div_id.'">
			</div>
			';
		print $html; 
		break; /* End case 'throbber': */
	
	} /* End switch ($plugintool_request) { */


/* FUNCTIONS */

function plugintool_state($state) {
	switch ($state) {
		case '0':
			$state_value = 'OK';
			break; /* End case '0': */
		
		case '1':
			$state_value = 'WARNING';
			break; /* End case '1': */
		
		
		case '2':
			$state_value = 'CRITICAL';
			break; /* End case '2': */
		
		case '3':
			$state_value = 'UNKNOWN';
			break; /* End case '3': */
		} /* End switch ($state) { */
	return $state_value;
	} /* End function plugintool_state($state) { */

	
function known_macros() {
	/* Get the resource file known macros */
	$resource_file = file('/usr/local/nagios/etc/resource.cfg');
	//print_r('resource_file ' . $resource_file . '<br />');
	$known_macros_array = array();
	foreach ($resource_file as $resource_file_line) {
		if (preg_match("/^[$]/",$resource_file_line)) {
			$resource_file_line_split = explode('=',$resource_file_line,2);
			$known_macros_array[] = array(
				'macro_name' => $resource_file_line_split[0],
				'macro_value' => $resource_file_line_split[1]
				); /* End $known_macros_array[] = array( */
			} /* End if (preg_match("/^[$]/",$resource_file_line)) { */
		} /* End foreach ($resource_file as $resource_file_line) { */
	//print_r('known_macros_array ' . $known_macros_array . '<br />');
	return ($known_macros_array);
	} /* End function known_macros() { */
	
